#include <iostream>
#include <fstream>
#include <sstream>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <vector>
#include <string>
#include <set>

struct Node {
	struct Node *next;
	int data;
};

typedef struct Node item;


std::string input_filename = "";
std::string output_filename = "";
std::ofstream outfile;
std::ifstream infile;


/* A template for all data formulas of interest. */
struct data_formula_struct {
	std::string operand1;
	std::string operand2;
	std::string op;
};

/* Number of lists to be tracked in the example. Read as input from the file "list-insert.input" */
int num_lists;

/* A vector of all data-formulas over a template of the form "var1 op var2" where op = {<, <=, ==} and var1 and var2
 * are all variables in the example (provided by the user).
 * The data formulas are evaluated over the lattice {bot, false, true, top}. */
std::vector<data_formula_struct> data_formulas;

/* A double dimension vector of strings which stores all the variables in the example. The x-dimension of the
 * 2D vector = <tt>num_lists</tt> + 3. The variables are stored in an hierarchichal manner where all the variables 
 * pointing into the same list are inserted into the same vector: variables[i]. In particular:
 * variables[0] = {nil}
 * variables[1] = {x | x is a pointer into list1} U {star1}
 * variables[2] = {x | x is a pointer into list2} U {star2}
 * ...
 * variables[num_lists+1] = {y1, y2}
 * variables[num_lists+2] = {x | x is an integer variable in the example} */
std::vector<std::vector<std::string> > variables;


void print_data_type(std::vector<bool> &data_type) {

	unsigned int i;
	for(i = 0; i < data_type.size(); i++) {
		if(data_type[i]) outfile << "1";
		else outfile << "0";
	}

}

/* TODO: Pass all the variables in the example as formal parameters to this method. */
void generate_valuation_words(Node *head, Node* cur) {

	for (int i = 1; i <= num_lists; i++) {
		Node *y1;
		/*
		 * TODO: In case of multiple lists, initialize y1 with the pointer to the respective list.
		 * For eg. the if-conditional when num_lists = 2:
		 * 	if (i == 1) y1 = head1; 
		 *	else if (i == 2) y1 = head2;
		 *	else ...
		 */
		if(i == 1) y1 = head;
		else {
			std::cout << "Number of lists in the example = " << num_lists << std::endl;
			std::cout << "Number of lists does not tally with the instrumentation code." << std::endl;
			exit(1);
		}

		while (y1) {

		
			for (int j = 1; j <= num_lists; j++) {
				Node *y2;
				/*
                                 * TODO: In case of multiple lists, initialize y1 with the pointer to the respective list.
                                 * For eg. the if-conditional when num_lists = 2:
                                 *      if (i == j) y2 = y1;
                                 *      else if (i < j && j == 1) y2 = head1;
                                 *      else if (i < j && j == 2) y2 = head2;
                                 *      else ...
                                 */
                                if (i == j) y2 = y1->next;
				else if (i < j && j == 1) y2 = head;
				else {
					std::cout << "Number of lists in the example = " << num_lists << std::endl;
					std::cout << "Number of lists does not tally with the instrumentation code." << std::endl;
					exit(1);
				}	
	
				while(y2) {


					// Store the valuation word in the data-base with its corresponding data_type.
					Node * node = NULL;
                                        outfile << "string:";

					/* TODO: Compare all the pointer variable in the program to node (NULL). */
					outfile << "{nil ";
					if (head == node) { outfile << "head ";  }
					if (cur == node) { outfile << "cur "; }
					if (y1 == node) { outfile << "y1 ";  }
					if (y2 == node) { outfile << "y2 ";  }
					outfile << "}";

					for (int k = 1; k <= num_lists; k++) {

				 		/* TODO: In case of multiple lists, initialize node with the pointer to the respective list. */
						if (k == 1) node = head;
						else {
							std::cout << "Number of lists does not tally with variable \"num_lists\"" << std::endl;
						}

						while (node) {


							/* TODO: Compare all the pointer variable in the program to node. */
                                                	outfile << "{";
							if (head == node) { outfile << "head ";  }
							if (cur == node) { outfile << "cur ";  }
							if (y1 == node) { outfile << "y1 ";  }
							if (y2 == node) { outfile << "y2 "; }
							outfile << "}";
		
							node = node->next;
						}

						/* TODO */
						if (k == 1 && k < num_lists) outfile << "{star1 }";
						/*else if (k == 2) outfile << "{star2 }";*/
					}

                                        

					std::vector<bool> data_type;
					std::vector<data_formula_struct>::iterator it;
					for(it = data_formulas.begin(); it < data_formulas.end(); it++) {

						int val1 = 0; int val2 = 0;
						bool is_bot = false;
						bool result = false;

						/* TODO: Manually match <tt>*it.operand1</tt> with each variable and 
						 * store the corresponding data value in <tt>val1</tt> */
						if((*it).operand1.compare("head") == 0) {
			
							if(head) val1 = head->data;
							else is_bot = true;

						} else if ((*it).operand1.compare("cur") == 0) {

							if(cur) val1 = cur->data;
							else is_bot = true;

						} else if ((*it).operand1.compare("y1") == 0) {
			
							if(y1) val1 = y1->data;
							else is_bot = true;

						} else if ((*it).operand1.compare("y2") == 0) {

							if(y2) val1 = y2->data;
							else is_bot = true;

						}	


						/* TODO: Manually match <tt>*it.operand2</tt> with each variable and 
						 * store the corresponding data value in <tt>val2</tt> */
						if((*it).operand2.compare("head") == 0) {
			
							if(head) val2 = head->data;
							else is_bot = true;

						} else if ((*it).operand2.compare("cur") == 0) {

							if(cur) val2 = cur->data;
							else is_bot = true;

						} else if ((*it).operand2.compare("y1") == 0) {
			
							if(y1) val2 = y1->data;
							else is_bot = true;

						} else if ((*it).operand2.compare("y2") == 0) {

							if(y2) val2 = y2->data;
							else is_bot = true;

						}


						if((*it).op.compare("<") == 0) {

							result = (val1 < val2);

						} else if ((*it).op.compare("<=") == 0) {
		
							result = (val1 <= val2);
							
						} else if ((*it).op.compare("==") == 0) {
		
							result = (val1 == val2);

						}

						/* Use the result to generate the data_type.
						 * Encode: is_bot = true --> 00
						 *   	   else result = true --> 10
						 *	   else result = false --> 01
						 */
						if(is_bot) {

							data_type.push_back(false);
							data_type.push_back(false);

						} else if (result) {

							data_type.push_back(true);
							data_type.push_back(false);

						} else {

							data_type.push_back(false);
							data_type.push_back(true);

						}


					}

					outfile << ":";
                                        print_data_type(data_type);
                                        outfile << std::endl;
					

					y2 = y2->next;
				}
			}
			
			y1 = y1->next;
		}
	}

	return;
}


void instrumentation_init() {

	std::string line;
	while (!infile.eof())	 {

		getline(infile, line);

		if(line.size() == 0)
			continue;
		
		if(line.compare(0, 10, "num_lists:") == 0) {
			line.replace(0, 10, "");
			std::stringstream convert(line);
			convert >> num_lists;
			/* one index for each list (1, 2, 3 ... onwards) + index zero for variable "nil" + 
			 * last index (num_lists + 3) for integer variables + last but one index (num_lists + 2) 
			 * for universal variables.
			 */
			variables.resize(num_lists + 3);

			continue;

		} else if (line.compare(0, 4, "list") == 0) {

			line.replace(0, 4, "");
			size_t pos = line.find(":", 0);
			if (pos != std::string::npos) {

				int list_index;
				std::stringstream convert(line.substr(0, pos+1));
				convert >> list_index;
				line.replace(0, pos+1, "");

				variables[list_index].push_back(line);
				continue;

			} else {

				std::cout << "Invalid input file format" << std::endl;
				exit(1);
			}

		} else if (line.compare(0, 8, "integer:") == 0) {

			line.replace(0, 8, "");

			variables[num_lists+2].push_back(line);
			continue;

		} else if (line.compare(0, 10, "universal:") == 0) {

			line.replace(0, 10, "");

			variables[num_lists+1].push_back(line);
			continue;

		} else {

			std::cout << "Invalid input file format" << std::endl;
			exit(1);

		}

	}

	std::vector<std::string> flat_vars;
	/*for (std::vector<std::vector<std::string> >::iterator it1 = variables.begin(); it1 < variables.end(); it1++) {
		for (std::vector<std::string>::iterator it2 = it1->begin(); it2 < it1->end(); it2++) {

			flat_vars.push_back(*it2);
		}
	}*/
	for (unsigned int i = num_lists + 1; i <= num_lists + 2; i++) {
                for (std::vector<std::string>::iterator it2 = variables[i].begin(); it2 < variables[i].end(); it2++) {

                        flat_vars.push_back(*it2);
                }
        }

	for (std::vector<std::string>::iterator it1 = flat_vars.begin(); it1 < flat_vars.end(); it1++) {
		for (std::vector<std::string>::iterator it2 = it1 + 1; it2 < flat_vars.end(); it2++) {

			data_formula_struct f;
			f.operand1 = *it1;
			f.operand2 = *it2;
	
			f.op = "<";
			data_formulas.push_back(f);
			
			f.op = "<=";
			data_formulas.push_back(f);

			f.op = "==";
			data_formulas.push_back(f);
		}
	}

	variables[0].push_back("nil");
	int count = 1;
	for (std::vector<std::vector<std::string> >::iterator it = variables.begin() + 1; it < variables.end() - 3; it++) {
		std::stringstream convert;
		convert << count;
		std::string str = "star";
		str += convert.str();
		it->push_back(str);
		count++;
	}

	
	for (std::vector<data_formula_struct>::iterator it = data_formulas.begin(); it < data_formulas.end(); it++) {
		outfile << "data_formula:" << it->operand1.c_str() << " " << it->op.c_str() << " " << it->operand2.c_str() << "." << std::endl;
	}

	count = 0;
	for (std::vector<std::vector<std::string> >::iterator it1 = variables.begin(); it1 < variables.end() - 1; it1++) {
		for (std::vector<std::string>::iterator it2 = it1->begin(); it2 < it1->end(); it2++) {

			outfile << "variable:" << it2->c_str() << ":" << count << "." << std::endl;
			count++;
		}
	}

}


void siftDown(int numbers[], int root, int bottom) {
  int maxChild = root * 2 + 1;
 
  // Find the biggest child
  if(maxChild < bottom) {
    int otherChild = maxChild + 1;
    // Reversed for stability
    maxChild = (numbers[otherChild] > numbers[maxChild])?otherChild:maxChild;
  } else {
    // Don't overflow
    if(maxChild > bottom) return;
  }
 
  // If we have the correct ordering, we are done.
  if(numbers[root] >= numbers[maxChild]) return;
 
  // Swap
  int temp = numbers[root];
  numbers[root] = numbers[maxChild];
  numbers[maxChild] = temp;
 
  // Tail queue recursion. Will be compiled as a loop with correct compiler switches.
  siftDown(numbers, maxChild, bottom);
}


void heapSort(int numbers[], int array_size) {
  int i, temp;
 
  for (i = (array_size / 2); i >= 0; i--) {
    siftDown(numbers, i, array_size - 1);
  }
 
  for (i = array_size-1; i >= 1; i--) {
    // Swap
    temp = numbers[0];
    numbers[0] = numbers[i];
    numbers[i] = temp;
 
    siftDown(numbers, 0, i-1);
  }
}
 
Node * make_sorted_list(int A[], int size) {

	heapSort(A, size);
	int i = 0;

	Node *head = NULL;
	Node *cur = head;

	generate_valuation_words(head, cur);

	while(i < size) {
	
		Node *tmp =  (Node*)malloc(sizeof(Node));
		tmp->data = A[i];
		tmp->next = NULL;

		if(!cur) {

			head = tmp;
			cur = tmp;			
		}
		else {
			cur->next = tmp;
			cur = cur->next;
		}

		i++;


		generate_valuation_words(head, cur);

	}

	return head;

}

int main(int argc, char* argv[]) {

	if(argc != 3) {
                std::cout << "Incorrect arguments to the program\n";
                exit(-1);
        }
        else {
                input_filename = argv[1];
                output_filename = argv[2];
        }

	infile.open(input_filename.c_str(), std::ios::in);
	outfile.open(output_filename.c_str(), std::ios::out);


	instrumentation_init();

	item *head, *curr;
	srand(time(NULL));
	

	// Generate sample lists (of length atmost 5) populated with data values 0's, 1's and 2's.
	int len;

        std::set< std::vector<int> > list_contents;
        std::vector<int> temp_vector;
        temp_vector.push_back(0);
        list_contents.insert(temp_vector);

        temp_vector.clear();
        temp_vector.push_back(1);
        list_contents.insert(temp_vector);

        temp_vector.clear();
        temp_vector.push_back(2);
        list_contents.insert(temp_vector);

	int count = 0;
        for(len = 1; len <= 5; len++) {

                for(std::set< std::vector<int> >::iterator it = list_contents.begin(); it != list_contents.end(); it++) {
                        std::vector<int> contents = *it;
	
				int A[5];
				for(int i = 0; i < len; i++)
					A[i] = contents[i];

				head  = make_sorted_list(A, len);
				count++;

                                curr = head;
                                while (curr != NULL) {
                                        item * tmp = curr;
                                        curr = curr->next;
                                        delete tmp;
                                }
                }


		std::set< std::vector<int> > temp_set;
                for(std::set< std::vector<int> >::iterator it = list_contents.begin(); it != list_contents.end(); it++) {
                        temp_vector = *it;
                        temp_vector.push_back(0);
                        temp_set.insert(temp_vector);

                        temp_vector = *it;
                        temp_vector.push_back(1);
                        temp_set.insert(temp_vector);

                        temp_vector = *it;
                        temp_vector.push_back(2);
                        temp_set.insert(temp_vector);
                }
                list_contents = temp_set;
        }

	std::cout << "count: " << count << std::endl;
	outfile.close();
	infile.close();
	return 0;
}
